/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Morris Ku
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Morris Ku
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


bool
LogOpen(
	void
	)
{
	bool						bSuccess = false;


	do
	{
		if (LogNode != NULL)
		{
			fclose(LogNode);
			LogNode = NULL;
		}

		LogNode = fopen(LOG_FILENAME, "w+");
		if (LogNode == NULL)
		{
			//printf("fopen log fail, errno:%d\n", errno);
			break;
		}

		bSuccess = true;

	} while (false);

	return bSuccess;
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


void
LogClose(
	void
	)
{
	if (LogNode != NULL)
	{
		fclose(LogNode);
		LogNode = NULL;
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


