/***********************************************************************
 *
 *  Module      : 
 *  Description : 
 *
 *
 *  Author(s)   : Jason Lee
 *  Company     : SUNIX Co., Ltd.
 *  Maintain    : Jason Lee
 ***********************************************************************/


#include "sxx_precomp.h"


/*-----------------------------------------------------------------------------------------------------------------------------*/


char
SxxGetche(
	void
	)
{
	char						Data;
	struct termios				OldTermios;
	struct termios				NewTermios;
	int							Length;


	tcgetattr(0, &OldTermios);
	memcpy(&NewTermios, &OldTermios, sizeof(struct termios));

	NewTermios.c_lflag &= ~(ICANON | ECHO);

	tcsetattr(0, TCSANOW, &NewTermios);

	Length = read(0, &Data, 1);

	tcsetattr(0, TCSANOW, &OldTermios);

	if (Length == 1)
	{
		return Data;
	}
	else
	{
		return 0;
	}
}


/*-----------------------------------------------------------------------------------------------------------------------------*/


